indexing

	description: "Standard C last error number."

  author: "Berend de Boer"
	date: "$Date: 2001/12/27 $"
	revision: "$Revision: #1 $"

class

   STDC_ERRNO

inherit

   STDC_BASE

   CAPI_ERRNO

   CAPI_STRING


feature -- Access

   clear is
         -- reset error
      do
         posix_clear_errno
      end

   set_value (a_value: INTEGER) is
      do
         posix_set_errno (a_value)
      ensure
         value_set: value = a_value
      end


feature -- error set? Only valid if errno has been set!

   is_not_ok: BOOLEAN is
      do
         Result := value /= 0
      end

   is_ok: BOOLEAN is
      do
         Result := value = 0
      end


feature -- the current error value

   value: INTEGER is
         -- the error itself
      do
         Result := posix_errno
      end

   strerror, message: STRING is
         -- current error message
      local
         p: POINTER
      do
         p := posix_strerror (value)
         Result := sh.pointer_to_string (p)
      end


feature -- the first, whatever that means,  error value

   clear_first is
         -- reset notation of first error
      do
         first_value := 0
      ensure
         no_first_error: first_value = 0
      end

   first_value: INTEGER

   first_message: STRING is
         -- current error message
      local
         p: POINTER
      do
         p := posix_strerror (first_value)
         Result := sh.pointer_to_string (p)
      end

   set_first is
         -- make `first_value' equal to the current error value
      do
         first_value := value
      end


end -- class STDC_ERRNO
