indexing

   description: "Class that covers Windows child processes."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"


deferred class

   WINDOWS_CHILD_PROCESS


inherit

   WINDOWS_PROCESS

   ABSTRACT_CHILD_PROCESS


feature -- child's pid

   is_pid_valid: BOOLEAN is
         -- return True if this object refers to a child process, so
         -- it has an id
      do
         Result := my_pid > 0
      end


feature -- actions that parent may execute

   wait_for (suspend: BOOLEAN) is
         -- wait for this process to terminate. If `suspend' then we
         -- wait until the information about this process is available,
         -- else we return immediately.
         -- If suspend is False, check the terminated property to see
         -- if this child is really terminated.
      do
         -- to be implemented
      end


end -- class WINDOWS_CHILD_PROCESS
