indexing

	description: "Test Posix shared memory class."

  author: "Berend de Boer"
	date: "$Date: 2001/12/27 $"
	revision: "$Revision: #1 $"

class

   TEST_P_SHARED_MEMORY

inherit

   POSIX_SYSTEM

   POSIX_FILE_SYSTEM


creation

   make


feature

   make is
      local
         fd, fd2: POSIX_SHARED_MEMORY
      do
         print ("testing Posix shared memory interface.%N")

         if not supports_shared_memory_objects then
            print ("!! Shared memory objects not supported.%N")
         end

         print ("Create a shared memory object.%N")
         create fd.create_read_write ("/test.berend")

         fd.write_string ("Hello world.%N")
         fd.seek (6)
         fd.read_string (5)
         if not fd.last_string.is_equal ("world") then
            print ("!! expected string not matched.%N")
         end

         fd.close

         create fd2.open_read ("/test.berend")
         fd2.seek (6)
         fd2.read_string (5)
         if not fd2.last_string.is_equal ("world") then
            print ("!! expected string not matched.%N")
         end
         fd2.close

         unlink_shared_memory_object ("/test.berend")

         print ("End of Posix shared memory test.%N")
      end


end -- class TEST_P_SHARED_MEMORY
