indexing

   description: "Test SUS tcp sockets by using the echo service."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"


class

   TEST_S_ECHO


inherit

   POSIX_CURRENT_PROCESS


creation

   make

feature

   hello: STRING is "Hello World.%N"
   berend1: STRING is "hello berend%N"
   berend2: STRING is "hello berend"

   make is
      local
         host: SUS_HOST
         service: SUS_SERVICE
         echo_socket: SUS_TCP_SOCKET
         sa: SUS_SOCKET_ADDRESS
      do
         print ("Begin test echo using localhost.%N")

         -- create host.make_from_name ("bmach")
         create host.make_from_name ("localhost")
         create service.make_from_name ("echo", "tcp")

         create sa.make (host, service)

         create echo_socket.open_by_address (sa)
         echo_socket.write_string (hello)
         echo_socket.read_string (256)
         if not echo_socket.last_string.is_equal (hello) then
            print ("!! got: ")
            print (echo_socket.last_string)
         end
         echo_socket.write_string (berend1)
         echo_socket.read_string (256)
         if not echo_socket.last_string.is_equal (berend1) then
            print ("!! got: ")
            print (echo_socket.last_string)
         end

         -- when we write something without %N we block in read_string
         -- this shouldn't be the case for non_blocking i/o
         echo_socket.set_blocking_io (False)
         echo_socket.write_string (berend2)
         sleep (2) -- wait until got reply
         echo_socket.read_string (256)
         if not echo_socket.last_string.is_equal (berend2) then
            print ("!! got: ")
            print (echo_socket.last_string)
            print (", ")
            print (echo_socket.last_string.count)
            print (", ")
            print (berend2.count)
         end

         print ("End test echo.%N")
      end


end
